clear all
clc
%load simulation data
load('C:\Users\Wenli\Desktop\MCMC2\Model_p120\truegraph_p120.mat')

%define parameters
p=120;
q=12;
k=300;
m=100;

%Ising prior p1 method
%eta=10;


% Adaptive shrinkage p2 method
c=50;
%  a=0.1;
%  b=0.01;
 a=4;
 b=1;
%cut=0.05;
cut=0;
% save path
%foldername=strcat('Results_p1');
foldername=strcat('newResults_p120_c=',num2str(c),'_a=',num2str(a),'_b=',num2str(b),'_cut=',num2str(cut));
mkdir(['C:\Users\Wenli\Desktop\MCMC2\Model_p120\',foldername])
G=zeros(p+1);
G(2:p+1,2:p+1)=A;
%G=AA;
%common parameters
logv = -3:1:3;
logu=-1:1:6;

rng(1)

for j=1:m
    
    
    for i=1:length(logv)
        v=10^logv(i);
        
        
        for ii=1:length(logu)
            
            u=logu(ii);
            
            trainfile=strcat('C:\Users\Wenli\Desktop\MCMC2\Model_p120\training_Sigma=G_p=',int2str(p),'_',int2str(j),'.mat');
            load(trainfile)
            
            tic
            [beta,alpha,ar]=kbsvmadd3(X,y,G,u,v,c,a,b);
           % [beta,gamma]=kbsvm(X,y,u,eta,v,G);
            toc
            
            clear X x y
            testfile=strcat('C:\Users\Wenli\Desktop\MCMC2\Model_p120\validation_Sigma=G_p=',int2str(p),'_',int2str(j),'.mat');
            load(testfile)
            
            %p1 valiation
%             [t,ind]=calpredictionerror_p1(X,y,gamma,beta,k,p,q);
%             PA1{ii,i}=single(beta);
%             PA2{ii,i}=single(gamma);
                  
            %p2 valiation
            [t,ind]=calpredictionerror_p2(X,y,beta,k,p,q,cut);
            PA1{ii,i}=single(beta);
%             PA2{ii,i}=single(alpha);
%             AR(ii,i)=ar;
            
            T{ii,i}=t;
            IN{ii,i}=ind;
            
            
        end
        
    end
    
 %  save(['C:\Users\Wenli\Desktop\MCMC2\Model_p120\',foldername,'\tracefix_',num2str(j),'.mat'],'PA1','PA2','T','IN','logv','logu','AR','-v7.3')
   save(['C:\Users\Wenli\Desktop\MCMC2\Model_p120\',foldername,'\trace_',num2str(j),'.mat'],'PA1','T','IN','logv','logu','-v7.3')
   
    clear PA1
    clear PA2
    clear IN
     
   
   
end