  %%y -1 or 1, X include 1 vector to account for intercept, u and v are 
%%the sparcity and adpative parameters, G is the graph

function [ww,aa,ar]=kbsvmadd3(X,y,G,u,v,c,a,b)

nepoch=12000;
nstart=5000;

[k, n] = size(X);

%kappa=2;
pho=ones(n,1);
alpha=u*ones(k,1);
invtau=0.5*ones(k,1);

NewX=y.*X';
%mu = NewX\(ones(size(pho))+kappa*pho); %starting value of w



%w = zeros(k, 1);
w=standardsvm(X,y)';%starting value of w
W = zeros(k, nepoch);
AF = zeros(k, nepoch);
r=0;

for i = 1:nepoch
    i
    %sampling 'kappa'
       
    tmp=0.5*(pho+1-NewX*w).^2./pho;
    sumtmp = sum(tmp);
    kappa = gamrnd(a+1.5*n,1/(b+sumtmp));%%shape parameter A and scale parameter B mean AB
    
    % sampling 'invpho'
    invpho=random('inversegaussian',1./abs(1-NewX*w),kappa);
    invpho(find(invpho==0))=10^(-6);
    InvDpho=diag(invpho);
    pho=1./invpho;
     
    % Sampling 'invtau';invtau~=0
    invtau=random('inversegaussian',exp(alpha)./abs(w),exp(2*alpha));
    invtau(find(invtau==0))=10^(-6);
    invDt = diag(invtau);
   
    %sample beta
    invSigma=kappa*NewX'*InvDpho*NewX+invDt;
    [RR,~] = chol(invSigma);
    Mu_w=RR\(RR'\NewX'*InvDpho*kappa*(ones(size(pho))+pho));
    w = RR\randn(size(RR,1),1) + Mu_w;
    
    %save beta
    W(:, i) = w;
    
    %sampling alpha
    
   
    %create precison matrix Omiga
   B = tril(G,-1); % the lower triangle part of graph G
    [irow,icol]=find(B);
    BB=zeros(size(B));
    for jj=1:length(irow)
       BB(irow(jj),icol(jj))=gamrnd(a,1/(b+0.5*(alpha(irow(jj))-alpha(icol(jj)))^2/v));% gamma distributed numbers assigned to edges
     
    end
    O=BB+BB'-diag([diag(BB)]);% symmetric
    Omiga=diag(sum(O))+ eye(size(O))-O;
    %detOmiga=det(Omiga);
%    OME(:,:,i) = Omiga;
    % define H and J
    
    
    H=diag((1./invtau).*exp(2*alpha));
    J=ones(k,1);
    
    temp1=2*c*H+c*Omiga/v;
    L1 = chol(temp1,'lower') ;
%   alphasig=inv_chol(L1);
    %alphasig=inv(2*c*H+c*Omiga/v);
    alphamean=L1'\(L1\((2*c*H+(c-1)*Omiga/v)*alpha+2*J-H*J+u*J/v));%add 2
    %alphanew=mvnrnd(alphamean,alphasig)';
    alphanew = L1'\randn(size(L1',1),1) +alphamean;
    
    
    
    Hnew=diag((1./invtau).*exp(2*alphanew));
    temp2=2*c*Hnew+c*Omiga/v;
    L2 = chol(temp2, 'lower') ;
    %alphanewsig=inv(2*c*Hnew+c*Omiga/v);
%    alphanewsig=inv_chol(L2);
%     [alphanewsig,~]=choll1(alphanewsig);
    alphanewmean= L2'\(L2\((2*c*Hnew+(c-1)*Omiga/v)*alphanew+2*J-Hnew*J+u*J/v));%add 2
    
    logp1=sum(2*alphanew-0.5*exp(2*alphanew)./invtau)-0.5*(alphanew-u*J)'*Omiga*(alphanew-u*J)/v;%add 2
    logp2=sum(2*alpha-0.5*exp(2*alpha)./invtau)-0.5*(alpha-u*J)'*Omiga*(alpha-u*J)/v;%add 2
   % [pp,qq]=chol(alphanewsig);
    
    logp3=logmvnpdf2(alpha,alphanewmean,L2);
    logp4=logmvnpdf2(alphanew,alphamean,L1);
    p=exp(logp1-logp2+logp3-logp4);
    
    if rand< min(1,p)
        alpha=alphanew;
        r=r+1;
    end
   
   % mean(alpha)
    %save alpha
    AF(:, i) = alpha;
    
    
    
    
end


ww=W(1:k,nstart:nepoch);
aa=AF(1:k,nstart:nepoch);
ar=r/nepoch;
end




